
var FCKPanel = function( parentWindow )
{
	this.IsRTL			= ( FCKLang.Dir == 'rtl' ) ;
	this.IsContextMenu	= false ;
	this._LockCounter	= 0 ;
	
	this._Window = parentWindow || window ;
	
	var oDocument ;
	
	if ( FCKBrowserInfo.IsIE )
	{
		// Create the Popup that will hold the panel.
		this._Popup	= this._Window.createPopup() ;
		oDocument = this.Document = this._Popup.document ;
	}
	else
	{
		/*
		 * I inserted following line so that all calculations are done with
		 * respect to the current window, that is with respect to the FCKEditor
		 * itself. But to handle the error in the start when first panel is being
		 * painted I have to put an 'if' statement as well.
		 *
		 * Now it is positioning all floating panels correctly except the context 
		 * menu (which is not unexpected)
		 * 
		 * -Ashish Kumar Sinha <aksinha.iit@gmail.com>	
		 */
		 if(window.document.body != null)
		 	this._Window = window ;
			 
		 
		var oIFrame = this._IFrame = this._Window.document.createElement('iframe') ; 
		oIFrame.src					= 'javascript:void(0)' ;
		oIFrame.allowTransparency	= true ;
		oIFrame.frameBorder			= '0' ;
		oIFrame.scrolling			= 'no' ;
		oIFrame.style.position		= 'absolute';
		oIFrame.style.zIndex		= FCKConfig.FloatingPanelsZIndex ;
		oIFrame.width = oIFrame.height = 0 ;

		if ( this._Window == window.parent && window.frameElement )
			window.frameElement.parentNode.insertBefore( oIFrame, window.frameElement ) ;
		else
			this._Window.document.body.appendChild( oIFrame ) ;
		
		var oIFrameWindow = oIFrame.contentWindow ; 
		
		oDocument = this.Document = oIFrameWindow.document ;

		// Initialize the IFRAME document body.
		oDocument.open() ;
		oDocument.write( '<html><head></head><body style="margin:0px;padding:0px;"><\/body><\/html>' ) ;
		oDocument.close() ;

		FCKTools.AddEventListenerEx( oIFrameWindow, 'focus', FCKPanel_Window_OnFocus, this ) ;
		FCKTools.AddEventListenerEx( oIFrameWindow, 'blur', FCKPanel_Window_OnBlur, this ) ;
	}

	oDocument.dir = FCKLang.Dir ;
	
	oDocument.oncontextmenu = FCKTools.CancelEvent ;


	// Create the main DIV that is used as the panel base.
	this.MainNode = oDocument.body.appendChild( oDocument.createElement('DIV') ) ;

	// The "float" property must be set so Firefox calculates the size correcly.
	this.MainNode.style.cssFloat = this.IsRTL ? 'right' : 'left' ;

	if ( FCK.IECleanup )
		FCK.IECleanup.AddItem( this, FCKPanel_Cleanup ) ;
}
